﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace gy7
{
    class Program
    {
        static TSíkidom[] síkidom = new TSíkidom[10];
        static Random vélszám = new Random();

        public static void Main()
        {
            float a, b, x, y;
            for (int i = 0; i <= 9; i++)
            {
                a = vélszám.Next(1, 20);
                b = vélszám.Next(1, 20);
                x = vélszám.Next(1, 20);
                y = vélszám.Next(1, 20);
                switch (vélszám.Next(1, 5))
                {
                    case 1:
                        síkidom[i] = new TKör(x, y, a);
                        break;
                    case 2:
                        síkidom[i] = new TEllipszis(x, y, a, b);
                        break;
                    case 3:
                        síkidom[i] = new TNégyzet(x, y, a);
                        break;
                    default:
                        síkidom[i] = new TTéglalap(x, y, a, b);
                        break;
                }
            }

            Console.WriteLine("Eredeti sorrend:");
            foreach (TSíkidom Elem in síkidom)
            {
                Console.WriteLine(string.Format("{0,7:F1} {1}", Elem.Terület(), Elem.Név));
            }
            Console.WriteLine();

            // Rendezés:
            Array.Sort(síkidom);

            Console.WriteLine("Rendezett sorrend:");
            foreach (TSíkidom Elem in síkidom)
            {
                Console.WriteLine(string.Format("{0,7:F1} {1}", Elem.Terület(), Elem.Név));
            }

            Console.ReadLine();
        }
    }
}
