#ifndef TTEGLALAP_H
#define TTEGLALAP_H

#include "TNegyzet.h"
#include "ILapult.h"

class TTeglalap : public TNegyzet, public ILapult
{
    public:
        TTeglalap(float x, float y, float a, float b);
        float GetB() const  { return b; }
        void SetB(float ertek) { b = ertek; }
        float Terulet() const;
        string ToString() const;
        float GetAtlo() const;
        float Lapultsag() const;
        string GetNev() const { return TNegyzet::GetNev();}
    private:
        float b;
        const float faktor; // a radin tvltshoz fokra
};

#endif // TTEGLALAP_H


