#ifndef CONSOLE_H_INCLUDED
#define CONSOLE_H_INCLUDED

#include <windows.h>

class Console
{
  public:
    enum Color { BLACK = 0, GRAY = 7, GREEN = 10, CYAN, RED, MAGENTA, YELLOW,  WHITE };
    static void SetCursorPosition(int, int);
    static void ClearConsole();
    static void SetForegroundColor(int);
    static void SetSize(int, int);
    static int GetLargestWindowHeight();
    static int GetLargestWindowWidth();
	static int GetWindowWidth();
	static int GetWindowHeight();
    static void SetTitle(const char *title);
    static bool KeyPressed(int vkey);
    static void MsgBox(const char *title, const char *message);
    static void ClearInputBuffer();
};

#endif // CONSOLE_H_INCLUDED
