// Maximumkivlaszts rekurzival

#include <iostream>
#include <clocale>
using namespace std;
#include "Random.h"
Random velszam;

int *tomb;
int darab;

void Feltolt();
int Maximum(int);
int Maximum2(int);
int MaximumIndexe(int);

int main()
{
    setlocale(LC_ALL,"Hun");

    cout << "Maximumkivlaszts rekurzival\n";
    Feltolt();
    cout << "\nLegnagyobb rtk: " << Maximum(darab-1) << endl;
    cout << "          indexe: " << MaximumIndexe(darab-1) << endl;

    delete[] tomb;
    cin.get();
    return 0;
}

int Maximum(int n) {
    int result;
    if (n==0)
        result = tomb[0];
    else if (tomb[n]>Maximum(n-1))
        result = tomb[n];
    else
        result = Maximum(n-1);
    return result;
}

// Lehetne:
int Maximum2(int n) {
    if (n==0)
        return tomb[0];
    else if (tomb[n]>Maximum2(n-1))
        return tomb[n];
    else
        return Maximum2(n-1);
}

int MaximumIndexe(int n) {
    if (n==0)
        return 0;
    else if (tomb[n]>tomb[MaximumIndexe(n-1)])
        return n;
    else
        return MaximumIndexe(n-1);
}

void Feltolt() {
    darab = velszam.Next(5,10);
    tomb = new int[darab];
    for (int i=0; i<darab; i++)
        tomb[i] = velszam.Next(1,20);
    cout << "Tmbelemek:\n";
    for (int i=0; i<darab; i++)
        cout << tomb[i] << " ";
    cout << endl;
}
