// Kivlogats (pros tmbelemek)

#include <iostream>
#include <clocale>
using namespace std;
#include "Random.h"
Random velszam;

int *tomb, *ujtomb;
int darab;

void Kivalogat(int, int&);
void Feltolt();
void Kiir(int[], int);

int main()
{
    int darabParos;

    setlocale(LC_ALL,"Hun");

    cout << "A pros tmbelemek kivlogatsa\n";
    Feltolt();
    cout << "Tmbelemek: ";
    Kiir(tomb, darab);
    Kivalogat(darab-1, darabParos);
    cout << "Pros elemek: ";
    Kiir(ujtomb, darabParos);
    cout << darabParos << " elem";

    delete[] tomb;
    delete[] ujtomb;
    cin.get();
    return 0;
}

void Kivalogat(int n, int& dbParos) {
    if (n<0)
        dbParos = 0;
    else {
        Kivalogat(n-1, dbParos);
        if (tomb[n]%2 == 0)
            ujtomb[dbParos++] = tomb[n];
    }
}

void Feltolt() {
    darab = velszam.Next(5, 10);
    tomb = new int[darab];
    ujtomb = new int[darab];
    for (int i=0; i<darab; i++)
        tomb[i] = velszam.Next(1, 20);
}

void Kiir(int tomb[], int db) {
    for (int i=0; i<db; i++)
        cout << tomb[i] << " ";
    cout << endl;
}
