// Lineris keress nagy tmbben
// Szerepel-e az utols tmbelem a tmbelemek kztt?

#include <iostream>
#include <clocale>
#include <ctime>
using namespace std;

int *tomb;
int keresettElem = 9;

void Feltolt(long);
void Linkeres(int, bool&, int&);

int main()
{
    // const long elemszam = 60000UL;  // veremtlcsdorduls nlkl, brmelyik elemet megkeresei
    const long elemszam  = 500000000UL; // tlcsorduls
    bool van;
    int melyik;

    setlocale(LC_ALL,"Hun");

    cout << "Lineris keress nagy tmbben"<<endl;
    Feltolt(elemszam);
    Linkeres(elemszam-1, van, melyik);
    if (van)
        cout << "A(z) " << melyik << ". tmbelem a "<< keresettElem <<endl;
    else
        cout << "Nincs a "<<keresettElem<<" kzttk." << endl;

    delete[] tomb;
    cin.get();
    return 0;
}

void Linkeres(int n, bool& van, int& melyik) {
    if (n<0)
        van = false;
    else if (tomb[n]==keresettElem) {
        van = true;
        melyik = n;
    }
    else
        Linkeres(n-1, van, melyik);
}

void Feltolt(long darab) {
    tomb = new int[darab];
    for (int i=0; i<darab; i++)
        tomb[i] = 0;
    tomb[darab-1] = keresettElem;  // Az utols tmbelem legyen a keresett elem!
    cout << "Feltlts ksz.  - Indul a keress."<<endl;
}
