// Az utols tmbelemmel egyenl tmbelemek kivlogatsa nagy tmbbl

#include <iostream>
#include <clocale>
using namespace std;


int *tomb, *ujtomb;

void Kivalogat(int, int&);
void Feltolt(long);
void Kiir(int[], int);


// const long elemszam = 60000UL;  // veremtlcsdorduls nlkl
const long elemszam  = 100000UL;

int main()
{
    int darab;

    setlocale(LC_ALL,"Hun");

    cout << "Az utols tmbelemmel egyenl tmbelemek kivlogatsa nagy tmbbl" << endl;
    Feltolt(elemszam);
    Kivalogat(elemszam-1, darab);
    Kiir(ujtomb, darab);

    delete[] tomb;
    delete[] ujtomb;
    cin.get();
    return 0;
}

void Kivalogat(int n, int& db) {
    if (n<0)
        db = 0;
    else {
        Kivalogat(n-1, db);
        if (tomb[n] == tomb[elemszam-1])
            ujtomb[db++] = tomb[n];
    }
}

void Feltolt(long darab) {
    tomb = new int[darab];
    ujtomb = new int[darab];
    for (int i=0; i<darab; i++)
        tomb[i] = 0;
    tomb[darab-1] = 9;  // Az utols tmbelem legyen 9!
    cout << "Feltlts ksz.  - Indul a kivlogats."<<endl;
}

void Kiir(int tomb[], int db) {
    cout<<"Az utols tmbelemmel egyenl elemek szma: " <<  db << endl;
    for (int i=0; i<db; i++)
        cout << tomb[i] << " ";
    cout << endl;
}
