#ifndef RANDOM_H_INCLUDED
#define RANDOM_H_INCLUDED

#include <cmath>
#include <ctime>
#include <cstdlib>
using namespace std;

class Random
{
    public:
        Random() { srand((unsigned)time(NULL)); }
        Random(int seed) { srand(seed); }
        int Next() { return rand(); }
        int Next(int maxValue) { return rand() % maxValue;}
        int Next(int minValue, int maxValue) { return minValue + rand() % (maxValue-minValue); }
        double NextDouble() { return  Next() / (RAND_MAX+1.0); }
};

#endif








