// dikok rendezse magassg szerint
// (szmll rendezs)

#include <iostream>
#include <string>
#include <fstream>
#include <clocale>
using namespace std;

const string ut = "diakok.txt"; // az adatokat tartalmaz fjl elrsi tja
const int maxkulcs = 300;       // ennl magasabb dik nincs

struct tdiak {
    string nev;
    int magassag;    // kulcs mez
    float tomeg;
    bool fiu;
};

tdiak diak[300], ujdiak[300];
int nrekord = 0;

void Rendez();
void Beolvas();
void Kiir();

int main()
{
    setlocale(LC_ALL,"Hun");

    Beolvas();
    Rendez();
    Kiir();

    cin.get();
    return 0;
}

void Rendez() {
    int darab[maxkulcs];
    for (int i=0; i<maxkulcs; i++)
        darab[i] = 0;

    for (int i=0; i<nrekord; i++)
        darab[diak[i].magassag]++;

    for (int i=1; i<maxkulcs; i++)
        darab[i] += darab[i-1];

    for (int i=nrekord-1; i>=0; i--) {
        ujdiak[darab[diak[i].magassag]-1] = diak[i];
        darab[diak[i].magassag]--;
    }
}

void Beolvas() {
    string temp;
    ifstream fajl;
    fajl.open(ut.c_str());
    while (!fajl.eof()) {
        fajl >> diak[nrekord].nev;
        fajl >> temp;
        diak[nrekord].nev += " " + temp;
        fajl >> diak[nrekord].magassag;
        fajl >> diak[nrekord].tomeg;
        fajl >> temp;
        diak[nrekord].fiu = (temp.compare("fi")==0);
        nrekord++;
    }
    fajl.close();
}

void Kiir() {
    cout << "Magassg szerint rendezve:" << endl;
    for (int i=0; i<nrekord; i++) {
        cout.width(3);
        cout << i+1 << ". ";
        cout.width(3);
        cout << ujdiak[i].magassag << " cm " << ujdiak[i].nev << endl;
    }
}
