// Kombinatorikai algoritmusok
// Ismtlses permutcik

#include <iostream>
#include <iomanip>
#include <sstream>
#include <string>
#include <clocale>
using namespace std;

void Feltolt(int &);
void Permutaciok(int);
void Reverse(int [], int, int, int);

int *elem;

int main()
{
    setlocale(LC_ALL,"Hun");
    elem = new int[101];
    int n;

    Feltolt(n);
    Permutaciok(n);

    delete [] elem;
    cin.get();
    return 0;
}

void Feltolt(int &n)
{   // Az elemeket tartalmaz tmb feltltse
	string sorozat;
	cout << "Elemek (szmjegyek, szkzzel elvlasztva): ";
	getline(cin, sorozat);
	stringstream sinput(sorozat);
	n = 0;
	while (!sinput.eof())
	    sinput>>elem[n++];
}

void Permutaciok(int n)
{	// A permutcik meghatrozsa s kirsa:
	int db = 0, k, m, temp;
	do {
		// Kirs (az eredeti sorrenddel kezdjk):
		db += 1;
		cout << setw(3) << db << ".: ";
		for (int i = 0; i < n; i++) {
			cout<<elem[i];
		}
		cout<<endl;

		// Megkeressk az a legnagyobb k-t, amelyre elem(k) < elem(k+1)
		// (ha nincs ilyen, akkor nincs tbb permutci):
		k = n - 2;
		while (k >= 0 && elem[k] >= elem[k + 1])
			k--;

		if (k >= 0) {
			// Megkeressk azt a legnagyobb m-et, amelyre elem(k) < elem(m)
			// (biztosan van ilyen!):
			m = n-1;
			while (elem[k] >= elem[m])
				m--;

			// Felcserljk a K-adik s az L-edik elemet:
			temp = elem[k];
			elem[k] = elem[m];
			elem[m] = temp;
			// A k+1-edik elemtl a vgig megfordtjuk a tmbelemek sorrendjt:
            Reverse(elem, k + 1, n - k - 1, n);
		}
	} while (k >= 0);
}

void Reverse(int elem[], int start, int db, int n)
{
    int temp;
    if (start + db <= n) { // ha nem lp ki a tmbbl
        for (int i=0; i<db/2; i++) {
            temp = elem[start+i];
            elem[start+i] = elem[start+db-i-1];
            elem[start+db-i-1] = temp;
        }
    }
}
