#ifndef TVERSENY_H_INCLUDED
#define TVERSENY_H_INCLUDED

#include <vector>
#include <string>
#include "Tpalya.h"
#include "TVersenyzo.h"
using namespace std;

class TVerseny
{
    public:
        TPalya *palya;
        void Start();
        void Futas();
        void Eredmeny();
        void Var(int idotartam);
        void SetGyoztes(int ertek);
    private:
        static const int szunet = 500; // vrakozs ezredmsodpercben a lpsek kztt
        vector<TVersenyzo *>versenyzok;
        int versenyzokSzama;           // a versenyzk szma
        vector<int> gyoztesek;
        int GetVersenyzokSzama() { return versenyzokSzama; }
        void SetVersenyzokSzama(int ertek);
        string IntToString(int szam);
};

#endif // TVERSENY_H_INCLUDED
