﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        string melyikPizza = "", melyikFeltét = "", melyikSzósz = "";
        string[] szósz = new string[] { "bolognai", "tartár", "ketchup", "barbeque" };
        string[] pizza = new string[] { "Uránusz", "Himalája", "Carmen", "Holdsugár" };
        RadioButton[] választógomb;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // A választógombokat futásidőben hozzuk létre:
            választógomb = new RadioButton[szósz.Length];
            for (int i = 0; i < szósz.Length; i++)
            {
                választógomb[i] = new RadioButton();
                választógomb[i].Text = szósz[i];
                választógomb[i].Left = 20;
                választógomb[i].Top = 20 + 30 * i;
                választógomb[i].Click += new EventHandler(szószok);
                groupBox1.Controls.Add(választógomb[i]);
            }
            // A lenyílólista feltöltése futásidőben:
            foreach (string elem in pizza)
                comboBox1.Items.Insert(0, elem);
            comboBox1.Sorted = true;
            // A menüsor és az állapotsor tulajdonságai:
            pizzafajtaToolStripMenuItem.Checked = true;
            feltétToolStripMenuItem.Checked = true;
            szószToolStripMenuItem.Checked = true;
            toolStripStatusLabel1.Text = "";
            toolStripProgressBar1.Value = 10;

            button1.Enabled = false;
        }

        public void szószok(Object sender, EventArgs e)
        {
            melyikSzósz = ((RadioButton)sender).Text;
            kiír();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Pizzarendelés: " + melyikPizza + " - " + melyikSzósz + " - " + melyikFeltét, "Pizzafutár");
        }

        private void checkBox2_CheckedChanged(object sender, EventArgs e)
        {
            feltétek();
        }

        private void checkBox3_CheckedChanged(object sender, EventArgs e)
        {
            feltétek();
        }

        private void checkBox4_CheckedChanged(object sender, EventArgs e)
        {
            feltétek();
        }

        void feltétek()
        {
            melyikFeltét = "";
            if (checkBox2.Checked)
                melyikFeltét += checkBox2.Text + ", ";
            if (checkBox3.Checked)
                melyikFeltét += checkBox3.Text + ", ";
            if (checkBox4.Checked)
                melyikFeltét += checkBox4.Text + ", ";
            if (melyikFeltét != "")
                melyikFeltét = melyikFeltét.Substring(0, melyikFeltét.Length - 2); // levágjuk az utolsó vesszőt és szóközt
            kiír();
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            melyikPizza = (string)comboBox1.SelectedItem;
            kiír();
        }

        private void kilépésToolStripMenuItem_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void aProgramNévjegyeToolStripMenuItem_Click(object sender, EventArgs e)
        {
            MessageBox.Show("Pizzarendelés", "Pizzafutár");
        }

        private void feltétToolStripMenuItem_Click(object sender, EventArgs e)
        {
            feltétToolStripMenuItem.Checked = !feltétToolStripMenuItem.Checked;
            label1.Visible = !label1.Visible;
            checkBox2.Visible = !checkBox2.Visible;
            checkBox3.Visible = !checkBox3.Visible;
            checkBox4.Visible = !checkBox4.Visible;
            if (!feltétToolStripMenuItem.Checked)
            {
                checkBox2.Checked = false;
                checkBox3.Checked = false;
                checkBox4.Checked = false;
                melyikFeltét = "";
            }
            kiír();
        }

        private void szószToolStripMenuItem_Click(object sender, EventArgs e)
        {
            szószToolStripMenuItem.Checked = !szószToolStripMenuItem.Checked;
            if (szószToolStripMenuItem.Checked)
                groupBox1.Visible = true;
            else
            {
                groupBox1.Visible = false;
                for (int i=0; i<szósz.Length; i++)
                    választógomb[i].Checked = false;
                melyikSzósz = "";
            }
            kiír();
        }

        void kiír()
        {
            toolStripStatusLabel1.Text = melyikPizza + " - " + melyikSzósz + " - " + melyikFeltét;
            toolStripProgressBar1.Value = 10;
            if (melyikPizza != "")
                toolStripProgressBar1.Value += 30;
            if (melyikSzósz != "" || !szószToolStripMenuItem.Checked)
                toolStripProgressBar1.Value += 30;
            if (melyikFeltét != "" || !feltétToolStripMenuItem.Checked)
                toolStripProgressBar1.Value += 30;
            if (toolStripProgressBar1.Value == 100)
                button1.Enabled = true;
            else
                button1.Enabled = false;
        }
    }
}
