#include <iostream>
#include <string>
#include <fstream>
using namespace std;

const string ut = "diakok.txt";  // az adatokat tartalmaz fjl elrsi tja
const int maxmeret = 300;

struct tdiak {
    string nev;
    int magassag;
    float tomeg;
    bool fiu;
};

tdiak diak[maxmeret];
tdiak fiu[maxmeret];
tdiak lany[maxmeret];
int ndiak = 0;

void Szetvalogat(int&, int&);
void Beolvas();
void Kiir(int, int);

int main()
{
    setlocale(LC_ALL,"Hun");

    int fiukSzama, lanyokSzama;

    Beolvas();
    Szetvalogat(fiukSzama, lanyokSzama);
    Kiir(fiukSzama, lanyokSzama);

    cin.get();
}

void Szetvalogat(int& darab1, int& darab2) {
    darab1 = 0;
    darab2 = 0;
    for (int i=0; i<ndiak; i++) {
        if (diak[i].fiu)
            fiu[darab1++] = diak[i];
        else
            lany[darab2++] = diak[i];
    }
}

void Beolvas() {
    string temp;
    ifstream fajl;

    fajl.open(ut.c_str());
    while (!fajl.eof()) {
        fajl >> diak[ndiak].nev;
        fajl >> temp;
        diak[ndiak].nev += " " + temp;
        fajl >> diak[ndiak].magassag;
        fajl >> diak[ndiak].tomeg;
        fajl >> temp;
        diak[ndiak].fiu = (temp.compare("fi")==0);
        ndiak++;
    }
    fajl.close();
}

void Kiir(int darab1, int darab2) {
    cout << "Fik:" << endl;
    for (int i=0; i<darab1; i++) {
        cout.width(3);
        cout << i+1 << ". " << fiu[i].nev << endl;
    }
    cout << endl << "Lnyok:" << endl;
    for (int i=0; i<darab2; i++) {
        cout.width(3);
        cout << i+1 << ". " << lany[i].nev << endl;
    }
    cout << endl << "sszesen: " << darab1 << " fi s " << darab2 << " lny.";
}
