﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

// Kártyakeverés
// A képfájlokat először felvettük az erőforrások közé (Project/Properties/Resources/Add resource),
// majd a gy5.Properties.Resources.ResourceManager.GetObject() metódussal rendeltük hozzá a PictureBox Image tulajdonságához.
// (A számjeggyel kezdődő erőforrásnevek elé aláhúzásjel kerül.)

namespace gy3
{
    public partial class Form1 : Form
    {
        const int n = 52;
        const int szélesség = 71;
        const int magasság = 92;
        int[] lap = new int[n];
        int temp;
        Random vélszám = new Random();
        PictureBox[] kártya = new PictureBox[n];

        public Form1()
        {
            InitializeComponent();
        }

        private void Button1_Click(object sender, EventArgs e)
        {
            for (int i = 0, j; i < n; i++)
            {
                j = vélszám.Next(i, n);
                // csere:
                temp = lap[i];
                lap[i] = lap[j];
                lap[j] = temp;
            }
            Kiír();
        }

        public void Kiír()
        {
            for (int i = 0; i < n; i++)
            {
                kártya[i].Image = gy3.Properties.Resources.ResourceManager.GetObject("_" + lap[i]) as Image;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            int i;
            for (i = 0; i < n; i++)
            {
                lap[i] = i + 1;
            }

            i = 0;
            for (int sor = 0; sor <= 3; sor++)
            {
                for (int oszlop = 0; oszlop <= 12; oszlop++)
                {
                    kártya[i] = new PictureBox();
                    kártya[i].SizeMode = PictureBoxSizeMode.AutoSize;
                    kártya[i].Top = sor * (magasság + 5) + 50;
                    kártya[i].Left = oszlop * (szélesség + 2) + 20;
                    kártya[i].Image = gy3.Properties.Resources.ResourceManager.GetObject("_" + lap[i]) as Image;
                    this.Controls.Add(kártya[i]);
                    i++;
                }
            }

        }
    }
}
