// Tredkes htizsk-feladat
// Megolds moh algoritmussal

#include <iostream>
#include <iomanip>
#include <clocale>
#include <vector>
using namespace std;

float sMax = 50;    // a sly maximlis rtke (ennyit tud egyszerre elvinni)
float suly[] = { 10, 20, 30 };  // a trgyak slya
float ertek[] = { 30, 50, 60 }; // a trgyak rtke
const int elemErtek = sizeof(ertek) / sizeof(float);
vector <float> arany;

int main()
{
    setlocale(LC_ALL,"Hun");
    float osszsuly, osszertek, sulyad, ertekad, temp;
    int i, j;

	arany.resize(elemErtek);

	for (i = 0; i < elemErtek; i++) {
		arany[i] = ertek[i] / suly[i];
	}
	// Rendezs az arny alapjn cskken sorrendbe:
	for (i = 0; i < arany.size() - 1; i++) {
		for (j = i + 1; j < arany.size(); j++) {
			if (arany[i] < arany[j]) {
				temp = arany[i];
				arany[i] = arany[j];
				arany[j] = temp;
				temp = ertek[i];
				ertek[i] = ertek[j];
				ertek[j] = temp;
				temp = suly[i];
				suly[i] = suly[j];
				suly[j] = temp;
			}
		}
	}

	cout << "Trgyak:" << endl;
	for (i = 0; i < elemErtek; i++) {
	    cout<< setprecision(0) << fixed;
		cout<< setw(2)<< i + 1 <<". trgy: \t";
		cout<< setw(4)<< suly[i] <<" font, \t";
		cout<< setw(4)<< ertek[i] <<" dnr (";
		cout<< setw(6)<< setprecision(2) << fixed << arany[i] <<" dnr/font)" << endl;
	}
	cout << endl << "A htizskba fr: " << sMax << " kg" << endl;
	cout << "A htizskba kerl:" << endl;

	// Moh algoritmus:
	osszsuly = 0;
	osszertek = 0;
	for (i = 0; i < elemErtek; i++) {
		if (osszsuly + suly[i] <= sMax) {
			sulyad = suly[i];
			ertekad = ertek[i];
		} else {
			sulyad = sMax - osszsuly;
			ertekad = sulyad * arany[i];
		}
		osszsuly += sulyad;
		osszertek += ertekad;
		cout<< setw(2)<< i + 1 <<". trgy:\t";
        cout.width(7);
        cout.precision(1);
		cout << fixed << sulyad <<" font,\t ";
		cout << ertekad <<" dnr" << endl;
	}

	cout << "----------------------------------------------" << endl;
	cout.width(7);
	cout.precision(1);
	cout <<fixed<< "sszesen:          "<< osszsuly << " font,\t" << osszertek << " dnr" << endl;

    cin.get();
    return 0;
}
